Index: trunk/options/SPECIES/SPECIES_001
===================================================================
--- trunk/options/SPECIES/SPECIES_001	(revision 25)
+++ trunk/options/SPECIES/SPECIES_001	(revision 26)
@@ -7,6 +7,6 @@
 TRACER             Tracer name
 -999.9             Species half life
--9.9E-09           Wet deposition - A
-                   Wet deposition - B
+-9.9E-09           Below cloud scavenging - A
+                   Below cloud scavenging - B
 -9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 -9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
Index: trunk/options/SPECIES/SPECIES_002
===================================================================
--- trunk/options/SPECIES/SPECIES_002	(revision 25)
+++ trunk/options/SPECIES/SPECIES_002	(revision 26)
@@ -7,6 +7,6 @@
 O3                 Tracer name
 -999.9             Species half life
--9.9E-09           Wet deposition - A
-                   Wet deposition - B
+-9.9E-09           Below cloud scavenging - A
+                   Below cloud scavenging - B
 -9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 -9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
Index: trunk/options/SPECIES/SPECIES_003
===================================================================
--- trunk/options/SPECIES/SPECIES_003	(revision 25)
+++ trunk/options/SPECIES/SPECIES_003	(revision 26)
@@ -7,9 +7,9 @@
 NO                 Tracer name
 -999.9             Species half life
- 8.0E-06           Wet deposition - A
-0.62               Wet deposition - B
+ 8.0E-06           Below cloud scavenging - A
+0.62               Below cloud scavenging - B
 2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
 1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
  1.2               Dry deposition (gases) - D
Index: trunk/options/SPECIES/SPECIES_004
===================================================================
--- trunk/options/SPECIES/SPECIES_004	(revision 25)
+++ trunk/options/SPECIES/SPECIES_004	(revision 26)
@@ -7,9 +7,9 @@
 NO2                Tracer name
 -999.9             Species half life
- 1.0E-05           Wet deposition - A
-0.62               Wet deposition - B
+ 1.0E-05           Below cloud scavenging - A
+0.62               Below cloud scavenging - B
 2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
 1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
  1.6               Dry deposition (gases) - D
Index: trunk/options/SPECIES/SPECIES_005
===================================================================
--- trunk/options/SPECIES/SPECIES_005	(revision 25)
+++ trunk/options/SPECIES/SPECIES_005	(revision 26)
@@ -7,9 +7,9 @@
 HNO3               Tracer name
 -999.9             Species half life
- 5.0E-05           Wet deposition - A
-0.62               Wet deposition - B
+ 5.0E-05           Below cloud scavenging - A
+0.62               Below cloud scavenging - B
 2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
 1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
  1.9               Dry deposition (gases) - D
Index: trunk/options/SPECIES/SPECIES_006
===================================================================
--- trunk/options/SPECIES/SPECIES_006	(revision 25)
+++ trunk/options/SPECIES/SPECIES_006	(revision 26)
@@ -7,6 +7,6 @@
 HNO2               Tracer name
 -999.9             Species half life
--9.9E-09           Wet deposition - A
-                   Wet deposition - B
+-9.9E-09           Below cloud scavenging - A
+                   Below cloud scavenging - B
 -9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 -9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
Index: trunk/options/SPECIES/SPECIES_007
===================================================================
--- trunk/options/SPECIES/SPECIES_007	(revision 25)
+++ trunk/options/SPECIES/SPECIES_007	(revision 26)
@@ -7,9 +7,9 @@
 H2O2               Tracer name
 -999.9             Species half life
- 1.0E-04           Wet deposition - A
-0.62               Wet deposition - B
+ 1.0E-04           Below cloud scavenging - A
+0.62               Below cloud scavenging - B
 2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
 1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
  1.4               Dry deposition (gases) - D
Index: trunk/options/SPECIES/SPECIES_008
===================================================================
--- trunk/options/SPECIES/SPECIES_008	(revision 25)
+++ trunk/options/SPECIES/SPECIES_008	(revision 26)
@@ -7,6 +7,6 @@
 SO2                Tracer name
 -999.9             Species half life
--9.9E-09           Wet deposition - A
-0.62               Wet deposition - B
+-9.9E-09           Below cloud scavenging - A
+0.62               Below cloud scavenging - B
 -9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 -9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
Index: trunk/options/SPECIES/SPECIES_009
===================================================================
--- trunk/options/SPECIES/SPECIES_009	(revision 25)
+++ trunk/options/SPECIES/SPECIES_009	(revision 26)
@@ -7,6 +7,6 @@
 HCHO               Tracer name
 -999.9             Species half life
--9.9E-09           Wet deposition - A
-                   Wet deposition - B
+-9.9E-09           Below cloud scavenging - A
+                   Below cloud scavenging - B
 -9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 -9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
Index: trunk/options/SPECIES/SPECIES_010
===================================================================
--- trunk/options/SPECIES/SPECIES_010	(revision 25)
+++ trunk/options/SPECIES/SPECIES_010	(revision 26)
@@ -7,6 +7,6 @@
 PAN                Tracer name
 -999.9             Species half life
--9.9E-09           Wet deposition - A
-                   Wet deposition - B
+-9.9E-09           Below cloud scavenging - A
+                   Below cloud scavenging - B
 -9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 -9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
Index: trunk/options/SPECIES/SPECIES_011
===================================================================
--- trunk/options/SPECIES/SPECIES_011	(revision 25)
+++ trunk/options/SPECIES/SPECIES_011	(revision 26)
@@ -7,9 +7,9 @@
 NH3                Tracer name
 -999.9             Species half life
- 9.9E-05           Wet deposition - A
-0.62               Wet deposition - B
+ 9.9E-05           Below cloud scavenging - A
+0.62               Below cloud scavenging - B
 2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
 1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
  1.1               Dry deposition (gases) - D
Index: trunk/options/SPECIES/SPECIES_012
===================================================================
--- trunk/options/SPECIES/SPECIES_012	(revision 25)
+++ trunk/options/SPECIES/SPECIES_012	(revision 26)
@@ -7,9 +7,9 @@
 SO4-aero           Tracer name
 -999.9             Species half life
- 5.0E-06           Wet deposition - A
-0.62               Wet deposition - B
+ 5.0E-06           Below cloud scavenging - A
+0.62               Below cloud scavenging - B
 2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
 1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
Index: trunk/options/SPECIES/SPECIES_013
===================================================================
--- trunk/options/SPECIES/SPECIES_013	(revision 25)
+++ trunk/options/SPECIES/SPECIES_013	(revision 26)
@@ -7,9 +7,9 @@
 NO3-aero           Tracer name
 -999.9             Species half life
- 5.0E-06           Wet deposition - A
-0.62               Wet deposition - B
+ 5.0E-06           Below cloud scavenging - A
+0.62               Below cloud scavenging - B
 2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
 1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
Index: trunk/options/SPECIES/SPECIES_014
===================================================================
--- trunk/options/SPECIES/SPECIES_014	(revision 25)
+++ trunk/options/SPECIES/SPECIES_014	(revision 26)
@@ -7,9 +7,9 @@
 I2-131             Tracer name
 691200.0           Species half life
- 8.0E-05           Wet deposition - A
-0.62               Wet deposition - B
+ 8.0E-05           Below cloud scavenging - A
+0.62               Below cloud scavenging - B
 2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
 1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
  2.7               Dry deposition (gases) - D
Index: trunk/options/SPECIES/SPECIES_015
===================================================================
--- trunk/options/SPECIES/SPECIES_015	(revision 25)
+++ trunk/options/SPECIES/SPECIES_015	(revision 26)
@@ -7,9 +7,9 @@
 I-131              Tracer name
 691200.0           Species half life
- 1.0E-04           Wet deposition - A
-0.80               Wet deposition - B
+ 1.0E-04           Below cloud scavenging - A
+0.80               Below cloud scavenging - B
 2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
 1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
Index: trunk/options/SPECIES/SPECIES_016
===================================================================
--- trunk/options/SPECIES/SPECIES_016	(revision 25)
+++ trunk/options/SPECIES/SPECIES_016	(revision 26)
@@ -7,9 +7,9 @@
 Cs-137             Tracer name
 -999.9             Species half life
- 1.0E-04           Wet deposition - A
-0.80               Wet deposition - B
+ 1.0E-04           Below cloud scavenging - A
+0.80               Below cloud scavenging - B
 2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
 1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
Index: trunk/options/SPECIES/SPECIES_017
===================================================================
--- trunk/options/SPECIES/SPECIES_017	(revision 25)
+++ trunk/options/SPECIES/SPECIES_017	(revision 26)
@@ -7,9 +7,9 @@
 Y-91               Tracer name
 5037120.0          Species half life
- 1.0E-04           Wet deposition - A
-0.80               Wet deposition - B
+ 1.0E-04           Below cloud scavenging - A
+0.80               Below cloud scavenging - B
 2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
 1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
Index: trunk/options/SPECIES/SPECIES_018
===================================================================
--- trunk/options/SPECIES/SPECIES_018	(revision 25)
+++ trunk/options/SPECIES/SPECIES_018	(revision 26)
@@ -7,9 +7,9 @@
 Ru-106             Tracer name
 31536000.0         Species half life
- 1.0E-04           Wet deposition - A
-0.80               Wet deposition - B
+ 1.0E-04           Below cloud scavenging - A
+0.80               Below cloud scavenging - B
 2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
 1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
Index: trunk/options/SPECIES/SPECIES_019
===================================================================
--- trunk/options/SPECIES/SPECIES_019	(revision 25)
+++ trunk/options/SPECIES/SPECIES_019	(revision 26)
@@ -7,6 +7,6 @@
 Kr-85              Tracer name
 -999.9             Species half life
--9.9E-09           Wet deposition - A
-                   Wet deposition - B
+-9.9E-09           Below cloud scavenging - A
+                   Below cloud scavenging - B
 -9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 -9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
Index: trunk/options/SPECIES/SPECIES_020
===================================================================
--- trunk/options/SPECIES/SPECIES_020	(revision 25)
+++ trunk/options/SPECIES/SPECIES_020	(revision 26)
@@ -7,9 +7,9 @@
 Sr-90              Tracer name
 -999.9             Species half life
- 1.0E-04           Wet deposition - A
-0.80               Wet deposition - B
+ 1.0E-04           Below cloud scavenging - A
+0.80               Below cloud scavenging - B
 2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
 1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
Index: trunk/options/SPECIES/SPECIES_021
===================================================================
--- trunk/options/SPECIES/SPECIES_021	(revision 25)
+++ trunk/options/SPECIES/SPECIES_021	(revision 26)
@@ -7,6 +7,6 @@
 Xe-133             Tracer name
 453168.0           Species half life
--9.9E-09           Wet deposition - A
-                   Wet deposition - B
+-9.9E-09           Below cloud scavenging - A
+                   Below cloud scavenging - B
 -9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 -9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
Index: trunk/options/SPECIES/SPECIES_022
===================================================================
--- trunk/options/SPECIES/SPECIES_022	(revision 25)
+++ trunk/options/SPECIES/SPECIES_022	(revision 26)
@@ -7,6 +7,6 @@
 CO                 Tracer name
 -999.9             Species half life
--9.9E-09           Wet deposition - A
-                   Wet deposition - B
+-9.9E-09           Below cloud scavenging - A
+                   Below cloud scavenging - B
 -9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 -9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
Index: trunk/options/SPECIES/SPECIES_024
===================================================================
--- trunk/options/SPECIES/SPECIES_024	(revision 25)
+++ trunk/options/SPECIES/SPECIES_024	(revision 26)
@@ -7,6 +7,6 @@
 AIRTRACER             Tracer name
 -999.9             Species half life
--9.9E-09           Wet deposition - A
-                   Wet deposition - B
+-9.9E-09           Below cloud scavenging - A
+                   Below cloud scavenging - B
 -9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 -9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
Index: trunk/options/SPECIES/SPECIES_025
===================================================================
--- trunk/options/SPECIES/SPECIES_025	(revision 25)
+++ trunk/options/SPECIES/SPECIES_025	(revision 26)
@@ -11,5 +11,5 @@
 2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
 0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.1                In-cloud scavenging - Ci (S_i=Ci/cl)
+0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
 1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D