Index: flexpart-testing/case_data/ecmwf_02hr_1p0deg_grib1-2/case_ecmwf_02hr_1p0deg_grib1-2_1species_1emission_bwd_CTBTO/control_output_ifort/dates
===================================================================
--- flexpart-testing/case_data/ecmwf_02hr_1p0deg_grib1-2/case_ecmwf_02hr_1p0deg_grib1-2_1species_1emission_bwd_CTBTO/control_output_ifort/dates	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
+++ flexpart-testing/case_data/ecmwf_02hr_1p0deg_grib1-2/case_ecmwf_02hr_1p0deg_grib1-2_1species_1emission_bwd_CTBTO/control_output_ifort/dates	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
@@ -0,0 +1,4 @@
+20131107013000
+20131107010000
+20131107003000
+20131107000000
Index: flexpart-testing/case_data/ecmwf_1p0deg_tinymet_multipletests/case_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_bwd_ctbto/control_output_ifort/dates
===================================================================
--- flexpart-testing/case_data/ecmwf_1p0deg_tinymet_multipletests/case_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_bwd_ctbto/control_output_ifort/dates	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
+++ flexpart-testing/case_data/ecmwf_1p0deg_tinymet_multipletests/case_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_bwd_ctbto/control_output_ifort/dates	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
@@ -0,0 +1,6 @@
+20140919050000
+20140919040000
+20140919030000
+20140919020000
+20140919010000
+20140919000000
Index: flexpart-testing/case_data/ecmwf_1p0deg_tinymet_multipletests/case_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_fwd_ctbto/control_output_ifort/dates
===================================================================
--- flexpart-testing/case_data/ecmwf_1p0deg_tinymet_multipletests/case_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_fwd_ctbto/control_output_ifort/dates	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
+++ flexpart-testing/case_data/ecmwf_1p0deg_tinymet_multipletests/case_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_fwd_ctbto/control_output_ifort/dates	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
@@ -0,0 +1,6 @@
+20140919010000
+20140919020000
+20140919030000
+20140919040000
+20140919050000
+20140919060000
Index: flexpart-testing/case_data/ncep_02hr_1p0deg/case_ncep_02hr_1p0deg_1species_1emission_bwd_CTBTO/control_output_ifort/dates
===================================================================
--- flexpart-testing/case_data/ncep_02hr_1p0deg/case_ncep_02hr_1p0deg_1species_1emission_bwd_CTBTO/control_output_ifort/dates	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
+++ flexpart-testing/case_data/ncep_02hr_1p0deg/case_ncep_02hr_1p0deg_1species_1emission_bwd_CTBTO/control_output_ifort/dates	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
@@ -0,0 +1,4 @@
+20150216013000
+20150216010000
+20150216003000
+20150216000000
Index: flexpart-testing/case_data/ncep_02hr_1p0deg/case_ncep_02hr_1p0deg_1species_1emission_bwd_CTBTO/par_mod.F90
===================================================================
--- flexpart-testing/case_data/ncep_02hr_1p0deg/case_ncep_02hr_1p0deg_1species_1emission_bwd_CTBTO/par_mod.F90	(revision 496c6079149f12fbb3e7ecf1f351470794679655)
+++ flexpart-testing/case_data/ncep_02hr_1p0deg/case_ncep_02hr_1p0deg_1species_1emission_bwd_CTBTO/par_mod.F90	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
@@ -203,5 +203,5 @@
   !**************************************************
 
-#if defined WITH_CTBTO_PATCHES
+#if defined CTBTO
   integer,parameter :: maxpart=30000000
   integer,parameter :: maxspec=1
Index: flexpart-testing/check/ctbto_cases/ifort/test_ecmwf_02hr_1p0deg_grib1-2_1species_1emission_bwd_ctbto.xml
===================================================================
--- flexpart-testing/check/ctbto_cases/ifort/test_ecmwf_02hr_1p0deg_grib1-2_1species_1emission_bwd_ctbto.xml	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
+++ flexpart-testing/check/ctbto_cases/ifort/test_ecmwf_02hr_1p0deg_grib1-2_1species_1emission_bwd_ctbto.xml	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
@@ -0,0 +1,63 @@
+<distribution>
+
+    <!-- Sample XML testing namelist -->
+
+    <short_descr>
+        Testing of Leo's GRIB1/2 data for small ECMWF 1.0 deg global
+    </short_descr>
+
+    <distropath>
+        ../../flexpart_code
+    </distropath>
+
+    <parmodpath>
+        ../case_data/ecmwf_02hr_1p0deg_grib1-2/case_ecmwf_02hr_1p0deg_grib1-2_1species_1emission_bwd_CTBTO/par_mod.F90
+    </parmodpath>
+
+    <execname>
+        flexpart_ifort
+    </execname>
+
+    <metcase>
+
+        <short_descr>
+            ECMWF global fields
+        </short_descr>
+
+        <metfiledir>
+            ../case_data/met_data/ecmwf/t1_03h_ec1p0d_grib1-2/
+        </metfiledir>
+
+        <runcase>
+            <short_descr>
+                Backward run, 2 hours length, 1 species, 1 emissions, no nested outgrid
+            </short_descr>
+
+            <casedir>
+                ../case_data/ecmwf_02hr_1p0deg_grib1-2/case_ecmwf_02hr_1p0deg_grib1-2_1species_1emission_bwd_CTBTO/rundir_template
+            </casedir>
+
+            <controldatadir>
+                ../case_data/ecmwf_02hr_1p0deg_grib1-2/case_ecmwf_02hr_1p0deg_grib1-2_1species_1emission_bwd_CTBTO/control_output_ifort
+            </controldatadir>
+
+
+            <basictest>
+                <short_descr>
+                    Max error over entire temporal and spatial mother domain
+                </short_descr>
+
+                <type>
+                    mother_all_vars_maxabserr
+                </type>
+
+                <max_threshold>
+                   1.0E-3
+                </max_threshold>
+            </basictest>
+
+        </runcase>
+
+    </metcase>
+
+</distribution>
Index: flexpart-testing/check/ctbto_cases/ifort/test_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_bwd_ctbto.xml
===================================================================
--- flexpart-testing/check/ctbto_cases/ifort/test_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_bwd_ctbto.xml	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
+++ flexpart-testing/check/ctbto_cases/ifort/test_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_bwd_ctbto.xml	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
@@ -0,0 +1,79 @@
+<distribution>
+
+    <!-- Sample XML testing namelist -->
+
+    <short_descr>
+        Testing of FLEXPART for very small ECMWF met file - CTBTO patches, GRIB1/2
+    </short_descr>
+
+    <distropath>
+        ../../flexpart_code
+    </distropath>
+
+    <parmodpath>
+        ../case_data/ecmwf_1p0deg_tinymet_multipletests/case_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_bwd_ctbto/par_mod.F90
+    </parmodpath>
+
+    <execname>
+        flexpart_ifort
+    </execname>
+
+    <metcase>
+
+        <short_descr>
+            ECMWF patch - 11x11 1.0 degrees over Austria
+        </short_descr>
+
+        <metfiledir>
+            ../case_data/met_data/ecmwf/t1_33h_ec1p0d
+        </metfiledir>
+
+        <runcase>
+            <short_descr>
+                Backward run, 1 species, 1 emissions, 6 hours
+            </short_descr>
+
+            <casedir>
+                ../case_data/ecmwf_1p0deg_tinymet_multipletests/case_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_bwd_ctbto/rundir_template
+            </casedir>
+
+            <controldatadir>
+                ../case_data/ecmwf_1p0deg_tinymet_multipletests/case_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_bwd_ctbto/control_output_ifort
+            </controldatadir>
+
+
+            <basictest>
+                <short_descr>
+                    Max error over entire temporal and spatial mother domain
+                </short_descr>
+
+                <type>
+                    mother_all_vars_maxabserr
+                </type>
+
+                <max_threshold>
+                   1.0E-3
+                </max_threshold>
+            </basictest>
+
+            <basictest>
+                <short_descr>
+                    RMS error over entire temporal and spatial mother domain
+                </short_descr>
+
+                <type>
+                    mother_all_vars_rmse
+                </type>
+
+                <max_threshold>
+                   1.0E-3
+                </max_threshold>
+            </basictest>
+
+
+        </runcase>
+
+
+    </metcase>
+
+</distribution>
Index: flexpart-testing/check/ctbto_cases/ifort/test_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_fwd_ctbto.xml
===================================================================
--- flexpart-testing/check/ctbto_cases/ifort/test_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_fwd_ctbto.xml	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
+++ flexpart-testing/check/ctbto_cases/ifort/test_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_fwd_ctbto.xml	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
@@ -0,0 +1,79 @@
+<distribution>
+
+    <!-- Sample XML testing namelist -->
+
+    <short_descr>
+        Testing of FLEXPART for very small ECMWF met file - CTBTO patches, GRIB1/2
+    </short_descr>
+
+    <distropath>
+        ../../flexpart_code
+    </distropath>
+
+    <parmodpath>
+        ../case_data/ecmwf_1p0deg_tinymet_multipletests/case_ecmwf_06hr_1p0deg_tinymetgrid_1species_1emission_bwd/par_mod.F90
+    </parmodpath>
+
+    <execname>
+        flexpart_ifort
+    </execname>
+
+    <metcase>
+
+        <short_descr>
+            ECMWF patch - 11x11 1.0 degrees over Austria
+        </short_descr>
+
+        <metfiledir>
+            ../case_data/met_data/ecmwf/t1_33h_ec1p0d
+        </metfiledir>
+
+        <runcase>
+            <short_descr>
+                Forward run, 1 species, 1 emissions, 6 hours
+            </short_descr>
+
+            <casedir>
+                ../case_data/ecmwf_1p0deg_tinymet_multipletests/case_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_fwd_ctbto/rundir_template
+            </casedir>
+
+            <controldatadir>
+                ../case_data/ecmwf_1p0deg_tinymet_multipletests/case_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_fwd_ctbto/control_output_ifort
+            </controldatadir>
+
+
+            <basictest>
+                <short_descr>
+                    Max error over entire temporal and spatial mother domain
+                </short_descr>
+
+                <type>
+                    mother_all_vars_maxabserr
+                </type>
+
+                <max_threshold>
+                   1.0E-3
+                </max_threshold>
+            </basictest>
+
+            <basictest>
+                <short_descr>
+                    RMS error over entire temporal and spatial mother domain
+                </short_descr>
+
+                <type>
+                    mother_all_vars_rmse
+                </type>
+
+                <max_threshold>
+                   1.0E-3
+                </max_threshold>
+            </basictest>
+
+
+        </runcase>
+
+
+    </metcase>
+
+</distribution>
Index: flexpart-testing/check/ctbto_cases/ifort/test_ncep_02hr_1p0deg_1species_1emission_bwd_ctbto.xml
===================================================================
--- flexpart-testing/check/ctbto_cases/ifort/test_ncep_02hr_1p0deg_1species_1emission_bwd_ctbto.xml	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
+++ flexpart-testing/check/ctbto_cases/ifort/test_ncep_02hr_1p0deg_1species_1emission_bwd_ctbto.xml	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
@@ -0,0 +1,63 @@
+<distribution>
+
+    <!-- Sample XML testing namelist -->
+
+    <short_descr>
+        Testing of Generic FLEXPART for small NCEP 1.0 deg global
+    </short_descr>
+
+    <distropath>
+        ../../flexpart_code
+    </distropath>
+
+    <parmodpath>
+        ../case_data/ncep_02hr_1p0deg/case_ncep_02hr_1p0deg_1species_1emission_bwd_CTBTO/par_mod.F90
+    </parmodpath>
+
+    <execname>
+        flexpart_ifort
+    </execname>
+
+    <metcase>
+
+        <short_descr>
+            NCEP global fields
+        </short_descr>
+
+        <metfiledir>
+            ../case_data/met_data/ncep/t1_03h_nc1p0d/
+        </metfiledir>
+
+        <runcase>
+            <short_descr>
+                Backward run, 2 hours length, 1 species, 1 emissions, no nested outgrid
+            </short_descr>
+
+            <casedir>
+                ../case_data/ncep_02hr_1p0deg/case_ncep_02hr_1p0deg_1species_1emission_bwd_CTBTO/rundir_template
+            </casedir>
+
+            <controldatadir>
+                ../case_data/ncep_02hr_1p0deg/case_ncep_02hr_1p0deg_1species_1emission_bwd_CTBTO/control_output_ifort
+            </controldatadir>
+
+
+            <basictest>
+                <short_descr>
+                    Max error over entire temporal and spatial mother domain
+                </short_descr>
+
+                <type>
+                    mother_all_vars_maxabserr
+                </type>
+
+                <max_threshold>
+                   1.0E-3
+                </max_threshold>
+            </basictest>
+
+        </runcase>
+
+    </metcase>
+
+</distribution>
Index: flexpart-testing/check/ctbto_cases_ifort.lst
===================================================================
--- flexpart-testing/check/ctbto_cases_ifort.lst	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
+++ flexpart-testing/check/ctbto_cases_ifort.lst	(revision 29feaef90b2bf29e14789b7a59f8e7a2964936d2)
@@ -0,0 +1,4 @@
+ctbto_cases/ifort/test_ecmwf_02hr_1p0deg_grib1-2_1species_1emission_bwd_ctbto.xml
+ctbto_cases/ifort/test_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_bwd_ctbto.xml
+ctbto_cases/ifort/test_ecmwf_06hr_1p0deg_grib1-2_tinymetgrid_1species_1emission_fwd_ctbto.xml
+ctbto_cases/ifort/test_ncep_02hr_1p0deg_1species_1emission_bwd_ctbto.xml