Index: Run/Control/CONTROL_CERA.global
===================================================================
--- Run/Control/CONTROL_CERA.global	(revision None)
+++ Run/Control/CONTROL_CERA.global	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -12,6 +12,6 @@
 GRID 2.  
 LEFT -178.
-LOWER -89.5
-UPPER 89.5
+LOWER -89.
+UPPER 89.
 RIGHT 180.
 LEVELIST 1/to/91
@@ -19,4 +19,4 @@
 ETA 1
 CWC 1
-PREFIX CE
+PREFIX CEg
 ECTRANS 1
Index: Run/Control/CONTROL_CERA.public
===================================================================
--- Run/Control/CONTROL_CERA.public	(revision None)
+++ Run/Control/CONTROL_CERA.public	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -13,9 +13,9 @@
 GRID 2.  
 LEFT -178.
-LOWER -89.5
-UPPER 89.5
+LOWER -89.
+UPPER 89.
 RIGHT 180.
 LEVELIST 1/to/91
-RESOL 106
+RESOL 159
 ETA 1
 CWC 1
Index: Run/Control/CONTROL_EA5
===================================================================
--- Run/Control/CONTROL_EA5	(revision None)
+++ Run/Control/CONTROL_EA5	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -1,4 +1,4 @@
 START_DATE 20180809
-DTIME 3
+DTIME 1
 TYPE AN AN AN AN AN AN AN AN AN AN AN AN AN AN AN AN AN AN AN AN AN AN AN AN
 TIME 00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23
@@ -11,9 +11,9 @@
 GRID 0.28125  
 LEFT -24.
-LOWER 10.
+LOWER 9.875
 UPPER 74.
-RIGHT 60.
+RIGHT 60.375
 LEVELIST 1/to/137
-RESOL 639
+RESOL 799
 ETA 1
 FORMAT GRIB2
Index: Run/Control/CONTROL_EA5.global
===================================================================
--- Run/Control/CONTROL_EA5.global	(revision None)
+++ Run/Control/CONTROL_EA5.global	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -18,4 +18,4 @@
 ETA 1
 CWC 1
-PREFIX EA
+PREFIX EAg
 ECTRANS 1
Index: Run/Control/CONTROL_EI
===================================================================
--- Run/Control/CONTROL_EI	(revision None)
+++ Run/Control/CONTROL_EI	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -9,11 +9,11 @@
 CLASS EI
 STREAM OPER
-GRID 1. #0.750  
-LEFT -25. #-24.75
-LOWER 10. #10.5
+GRID 0.750  
+LEFT -24.75
+LOWER 10.5
 UPPER 75.
 RIGHT 60.
-LEVELIST 50/to/60
-RESOL 319
+LEVELIST 1/to/60
+RESOL 255
 GAUSS 1
 FORMAT GRIB2
Index: Run/Control/CONTROL_EI.global
===================================================================
--- Run/Control/CONTROL_EI.global	(revision None)
+++ Run/Control/CONTROL_EI.global	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -15,7 +15,8 @@
 RIGHT 180.
 LEVELIST 1/to/60
-RESOL 319
+RESOL 255
 GAUSS 1
 FORMAT GRIB2
-PREFIX EI
+PREFIX EIg
+RRINT 1
 ECTRANS 1
Index: Run/Control/CONTROL_EI.public
===================================================================
--- Run/Control/CONTROL_EI.public	(revision None)
+++ Run/Control/CONTROL_EI.public	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -16,5 +16,5 @@
 RIGHT 180.
 LEVELIST 1/to/60
-RESOL 319
+RESOL 255
 GAUSS 1
 PREFIX EIpub  
Index: Run/Control/CONTROL_OD.ELDA.FC.eta.ens.double
===================================================================
--- Run/Control/CONTROL_OD.ELDA.FC.eta.ens.double	(revision None)
+++ Run/Control/CONTROL_OD.ELDA.FC.eta.ens.double	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -1,6 +1,6 @@
 START_DATE 20190505
 DTIME 3
-TYPE AN FC AN FC AN FC AN FC 
-TIME 00 18 06 06 12 06 18 18 
+TYPE AN FC AN FC AN FC AN FC
+TIME 00 18 06 06 12 06 18 18
 STEP 00 09 00 03 00 09 00 03
 ACCTIME 06/18
@@ -8,5 +8,5 @@
 ACCTYPE FC
 CLASS OD
-STREAM ELDA 
+STREAM ELDA
 PREFIX EL
 UPPER 5.
@@ -14,10 +14,11 @@
 LEFT -2.
 RIGHT 2.
-NUMBER 0/to/2
+NUMBER 0/to/25
 GRID 1.
-RESOL 159
 ETA 1
+RESOL 255
 LEVELIST 1/TO/137
 ECTRANS 1
 RRINT 1
 DOUBLEELDA 1
+CWC 1
Index: Run/Control/CONTROL_OD.ENFO.CF.36hours
===================================================================
--- Run/Control/CONTROL_OD.ENFO.CF.36hours	(revision None)
+++ Run/Control/CONTROL_OD.ENFO.CF.36hours	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -1,3 +1,3 @@
-START_DATE
+START_DATE 20190723
 DTIME 3
 MAXSTEP 36
@@ -16,5 +16,5 @@
 RIGHT 180.
 LEVELIST 1/to/91
-RESOL 159
+RESOL 255
 GAUSS 1
 PREFIX CF
Index: Run/Control/CONTROL_OD.ENFO.CV.36hours
===================================================================
--- Run/Control/CONTROL_OD.ENFO.CV.36hours	(revision eae74ecb6e08f682234ce28f70a83da8f31f2117)
+++ Run/Control/CONTROL_OD.ENFO.CV.36hours	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -17,5 +17,5 @@
 RIGHT 180.
 LEVELIST 1/to/91
-RESOL 159
+RESOL 255
 GAUSS 1
 PREFIX CV
Index: Run/Control/CONTROL_OD.ENFO.PF.36hours
===================================================================
--- Run/Control/CONTROL_OD.ENFO.PF.36hours	(revision None)
+++ Run/Control/CONTROL_OD.ENFO.PF.36hours	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -17,5 +17,5 @@
 RIGHT 180.
 LEVELIST 1/to/62
-RESOL 159
+RESOL 255
 GAUSS 1
 PREFIX EE
Index: Run/Control/CONTROL_OD.OPER.FC.36hours
===================================================================
--- Run/Control/CONTROL_OD.OPER.FC.36hours	(revision None)
+++ Run/Control/CONTROL_OD.OPER.FC.36hours	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -16,5 +16,5 @@
 UPPER 60.
 RIGHT 60.
-RESOL 159
+RESOL 255
 ETA 1
 CWC 1
Index: Run/Control/CONTROL_OD.OPER.FC.eta.basetime
===================================================================
--- Run/Control/CONTROL_OD.OPER.FC.eta.basetime	(revision None)
+++ Run/Control/CONTROL_OD.OPER.FC.eta.basetime	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -15,5 +15,5 @@
 STREAM OPER
 GRID 1.
-RESOL 159
+RESOL 255
 ETA 1
 LEVELIST 1/to/137
Index: Run/Control/CONTROL_OD.OPER.FC.eta.global
===================================================================
--- Run/Control/CONTROL_OD.OPER.FC.eta.global	(revision None)
+++ Run/Control/CONTROL_OD.OPER.FC.eta.global	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -15,7 +15,7 @@
 RIGHT 180.
 LEVEL 137
-RESOL 159
+RESOL 255
 ETA 1
 FORMAT GRIB2
-PREFIX ENH_
+PREFIX ENg
 ECTRANS 1
Index: Run/Control/CONTROL_OD.OPER.FC.eta.highres
===================================================================
--- Run/Control/CONTROL_OD.OPER.FC.eta.highres	(revision None)
+++ Run/Control/CONTROL_OD.OPER.FC.eta.highres	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -15,4 +15,4 @@
 ETA 1
 FORMAT GRIB2
-PREFIX ENH_
+PREFIX ENH
 ECTRANS 1
Index: Run/Control/CONTROL_OD.OPER.FC.gauss.global
===================================================================
--- Run/Control/CONTROL_OD.OPER.FC.gauss.global	(revision c905313a8b102d99510ad05c7effd7d0dc95c1c5)
+++ Run/Control/CONTROL_OD.OPER.FC.gauss.global	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -9,13 +9,13 @@
 CLASS OD
 STREAM OPER
-GRID 0.2  
-LEFT -10.
-LOWER 30.
-UPPER 60.
-RIGHT 30.
+GRID 1.0 
+LEFT -179.
+LOWER -90.
+UPPER 90.
+RIGHT 180.
 LEVEL 137
-RESOL 799
+RESOL 255
 GAUSS 1
 FORMAT GRIB2
-PREFIX ENHG_
+PREFIX ENgHG
 ECTRANS 1
Index: Run/Control/CONTROL_OD.OPER.FC.gauss.highres
===================================================================
--- Run/Control/CONTROL_OD.OPER.FC.gauss.highres	(revision None)
+++ Run/Control/CONTROL_OD.OPER.FC.gauss.highres	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -18,4 +18,4 @@
 GAUSS 1
 FORMAT GRIB2
-PREFIX ENHG_
+PREFIX ENHG
 ECTRANS 1
Index: Run/Control/CONTROL_OD.OPER.FC.operational
===================================================================
--- Run/Control/CONTROL_OD.OPER.FC.operational	(revision None)
+++ Run/Control/CONTROL_OD.OPER.FC.operational	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -13,5 +13,5 @@
 STREAM OPER
 GRID 1.
-RESOL 159
+RESOL 255
 ETA 1
 LEVELIST 1/to/137
@@ -19,3 +19,3 @@
 ECTRANS 1
 CWC 1
-PREFIX FCoper_
+PREFIX FCoper
Index: Run/Control/CONTROL_OD.OPER.FC.twiceaday.1hourly
===================================================================
--- Run/Control/CONTROL_OD.OPER.FC.twiceaday.1hourly	(revision None)
+++ Run/Control/CONTROL_OD.OPER.FC.twiceaday.1hourly	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -16,7 +16,7 @@
 UPPER 60.
 RIGHT 60.
-RESOL 159
+RESOL 255
 ETA 1
 CWC 1
-PREFIX FC1hd_
+PREFIX FC1hd
 ECTRANS 1
Index: Run/Control/CONTROL_OD.OPER.FC.twiceaday.3hourly
===================================================================
--- Run/Control/CONTROL_OD.OPER.FC.twiceaday.3hourly	(revision None)
+++ Run/Control/CONTROL_OD.OPER.FC.twiceaday.3hourly	(revision 33a4ccc6a3d85799aa73e496b4014dcc745ba7b6)
@@ -16,7 +16,7 @@
 UPPER 60.
 RIGHT 60.
-RESOL 159
+RESOL 255
 ETA 1
 CWC 1
-PREFIX FC3hd_
+PREFIX FC3hd
 ECTRANS 1